package com.data.gps2url;

import java.io.BufferedReader;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;

import org.apache.http.HttpEntity;
import org.apache.http.HttpHost;
import org.apache.http.HttpResponse;
import org.apache.http.HttpStatus;
import org.apache.http.NameValuePair;
import org.apache.http.StatusLine;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.ResponseHandler;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.conn.params.ConnManagerParams;
import org.apache.http.conn.params.ConnRoutePNames;
import org.apache.http.impl.client.BasicResponseHandler;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.params.HttpConnectionParams;
import org.apache.http.params.HttpParams;
import org.apache.http.util.EntityUtils;

import android.app.Activity;
import android.app.Notification;
import android.app.NotificationManager;
import android.content.Context;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Handler;
import android.telephony.TelephonyManager;
import android.util.Log;
import android.view.Menu;
import android.view.View;
import android.widget.TextView;
import android.widget.Toast;



public class GPS extends Activity implements LocationListener {
	
	private LocationManager myManager;
	
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_gps);
	    TelephonyManager telephonyManager = (TelephonyManager)getSystemService(Context.TELEPHONY_SERVICE);
        myManager = (LocationManager) getSystemService(LOCATION_SERVICE);
        myManager.requestLocationUpdates(LocationManager.GPS_PROVIDER, 0, 0, this);

	    String getURL = "http://smart-home-url/file.php?trace=init&device="+getDeviceID(telephonyManager);      
        //new MyAsyncTask(this).execute(getURL);
	    new GetAsyncTask(this).execute(getURL);
    }

    
    public void send(View v)
    {
    
	    TelephonyManager telephonyManager = (TelephonyManager)getSystemService(Context.TELEPHONY_SERVICE);
	    String getURL = "http://smart-home-url/file.php?trace=alert&device="+getDeviceID(telephonyManager);      
        //new MyAsyncTask(this).execute(getURL);
        new GetAsyncTask(this).execute(getURL);
    
    }
    
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.activity_gps, menu);
        return true;
    }
    
	@Override
	public void onLocationChanged(Location location) {
		// TODO Auto-generated method stub
		TextView tx = (TextView) findViewById(R.id.textView1);
		
	    TelephonyManager telephonyManager = (TelephonyManager)getSystemService(Context.TELEPHONY_SERVICE);

		tx.setText("Широта: "   + location.getLatitude()  + "\nДолгота: " + location.getLongitude() + "\nВысота" + location.getAltitude() + "\nСкорость: " + location.getSpeed() + "\nТочность: "+location.getAccuracy()+"\nВремя спутника: "+location.getTime()+"\n");      	
        String getURL = "http://smart-home-url/file.php?lat="+location.getLatitude()+"&lon="+location.getLongitude()+"&alt="+location.getAltitude()+"&acc="+location.getAccuracy()+"&time="+location.getTime()+"&device="+getDeviceID(telephonyManager);
        //new MyAsyncTask(this).execute(getURL);
        new GetAsyncTask(this).execute(getURL);
	}

	String getDeviceID(TelephonyManager phonyManager){ 
		 String id = phonyManager.getDeviceId();
		 return id; 
		}
	
	@Override
	public void onProviderDisabled(String provider) {
		// TODO Auto-generated method stub
		TextView tx = (TextView) findViewById(R.id.textView1);
		tx.setText("GPS is disabled\n");		
	}

	@Override
	public void onProviderEnabled(String provider) {
		// TODO Auto-generated method stub
		TextView tx = (TextView) findViewById(R.id.textView1);
		tx.setText("Waiting... GPS\n"); 	
        Toast.makeText(this, "Status waiting...", Toast.LENGTH_SHORT).show();
	}

	@Override
	public void onStatusChanged(String provider, int status, Bundle extras) {
		// TODO Auto-generated method stub
        Toast.makeText(this, "Status Changed", Toast.LENGTH_SHORT).show();
	}

    
}
